// Copyright 2014, 2015 by Sascha L. Teichmann
// Use of this source code is governed by the GPLv3 or later license
// that can be found in the LICENSE file.

package main

const (
	effectNone = effectKind(-1)
	effectHit  = effectKind(iota)
	effectBurn
	effectMiss
)

var effects = [...]effect{
	effectHit: {
		ch:  '*',
		col: TRed,
	},
	effectBurn: {
		ch:  '+',
		col: TWhite,
	},
	effectMiss: {
		ch:  'x',
		col: TYellow,
	},
}

const (
	itemTrash = iota
	itemUmbrella
	itemAxe
	itemBlowtorch
	itemChainsaw
	itemRevolver
	itemNailGun
	itemShotgun
	itemMolotov
	itemChocolates
	itemRation
	itemMedPack
	itemWoundSpray
	itemCanOfSpam
	itemTeddyBear
)

var items = [...]item{
	itemTrash: {
		Name:       "---",
		Sound:      "",
		Kind:       itemKindTrash,
		CrateProb:  0,
		CorpseProb: 8,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    0,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemUmbrella: {
		Name:       "umbrella",
		Sound:      "Whack",
		Kind:       itemKindWeapon,
		CrateProb:  2,
		CorpseProb: 6,
		Accuracy:   70,
		Blood:      20,
		Lethal:     30,
		Charges:    0,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemAxe: {
		Name:       "axe",
		Sound:      "Hack",
		Kind:       itemKindWeapon,
		CrateProb:  8,
		CorpseProb: 0,
		Accuracy:   85,
		Blood:      60,
		Lethal:     50,
		Charges:    0,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       true,
		Noisy:      false,
	},
	itemBlowtorch: {
		Name:       "blowtorch",
		Sound:      "Sslsh",
		Kind:       itemKindWeapon,
		CrateProb:  4,
		CorpseProb: 0,
		Accuracy:   75,
		Blood:      0,
		Lethal:     0,
		Charges:    3,
		Heal:       0,
		Food:       0,
		Burn:       true,
		Push:       false,
		Noisy:      false,
	},
	itemChainsaw: {
		Name:       "chainsaw",
		Sound:      "Wrrrooaaam!",
		Kind:       itemKindWeapon,
		CrateProb:  2,
		CorpseProb: 0,
		Accuracy:   100,
		Blood:      200,
		Lethal:     100,
		Charges:    6,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       true,
		Noisy:      true,
	},
	itemRevolver: {
		Name:       "revolver",
		Sound:      "Bang!",
		Kind:       itemKindGun,
		CrateProb:  0,
		CorpseProb: 6,
		Accuracy:   95,
		Blood:      40,
		Lethal:     60,
		Charges:    6,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      true,
	},
	itemNailGun: {
		Name:       "nail gun",
		Sound:      "Zing!",
		Kind:       itemKindGun,
		CrateProb:  8,
		CorpseProb: 0,
		Accuracy:   70,
		Blood:      20,
		Lethal:     40,
		Charges:    24,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemShotgun: {
		Name:       "shotgun",
		Sound:      "Blam!",
		Kind:       itemKindGun,
		CrateProb:  0,
		CorpseProb: 4,
		Accuracy:   100,
		Blood:      80,
		Lethal:     70,
		Charges:    8,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       true,
		Noisy:      true,
	},
	itemMolotov: {
		Name:       "molotov",
		Sound:      "Swoosh!",
		Kind:       itemKindGun,
		CrateProb:  0,
		CorpseProb: 15,
		Accuracy:   90,
		Blood:      0,
		Lethal:     10,
		Charges:    0,
		Heal:       0,
		Food:       0,
		Burn:       true,
		Push:       false,
		Noisy:      false,
	},
	itemChocolates: {
		Name:       "chocolates",
		Sound:      "Yummy, my favorite.",
		Kind:       itemKindFood,
		CrateProb:  0,
		CorpseProb: 12,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    6,
		Heal:       0,
		Food:       10,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemRation: {
		Name:       "ration",
		Sound:      "Munch, munch!",
		Kind:       itemKindFood,
		CrateProb:  0,
		CorpseProb: 12,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    0,
		Heal:       0,
		Food:       40,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemMedPack: {
		Name:       "med pack",
		Sound:      "Much better!",
		Kind:       itemKindFood,
		CrateProb:  4,
		CorpseProb: 2,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    0,
		Heal:       3,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemWoundSpray: {
		Name:       "wound spray",
		Sound:      "Psshh!",
		Kind:       itemKindFood,
		CrateProb:  0,
		CorpseProb: 5,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    3,
		Heal:       1,
		Food:       0,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemCanOfSpam: {
		Name:       "can of spam",
		Sound:      "Lovely spam.",
		Kind:       itemKindFood,
		CrateProb:  0,
		CorpseProb: 8,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    0,
		Heal:       0,
		Food:       60,
		Burn:       false,
		Push:       false,
		Noisy:      false,
	},
	itemTeddyBear: {
		Name:       "teddy bear",
		Sound:      "Hug me!",
		Kind:       itemKindWeapon,
		CrateProb:  0,
		CorpseProb: 4,
		Accuracy:   100,
		Blood:      0,
		Lethal:     0,
		Charges:    0,
		Heal:       0,
		Food:       0,
		Burn:       false,
		Push:       true,
		Noisy:      false,
	}}

const (
	tileFloor = iota
	tileWall
	tileCorpse
	tilePileOfFlesh
	tilePileOfRubble
	tileRuinedWall
	tileBloodPool
	tileBloodStain
	tileBloodyWall
	tileCrate
	tileEscalatorDown
	tileEscalatorUp
	tileClosedDoor
	tileOpenDoor
	tileMachinery
	tileBloodyMachinery
	tileExit
)

var tiles = [...]tile{
	tileFloor: {
		Name:      "floor",
		Change:    tilePileOfRubble,
		Lethal:    0,
		Ch:        '.',
		Color:     TLightGray,
		Item:      false,
		Shadow:    true,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileWall: {
		Name:      "wall",
		Change:    tileRuinedWall,
		Lethal:    0,
		Ch:        '#',
		Color:     TLightGray,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: false,
	},
	tileCorpse: {
		Name:      "corpse",
		Change:    tilePileOfFlesh,
		Lethal:    0,
		Ch:        '%',
		Color:     TLightRed,
		Item:      true,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: true,
	},
	tilePileOfFlesh: {
		Name:      "pile of flesh",
		Change:    tilePileOfFlesh,
		Lethal:    0,
		Ch:        '+',
		Color:     TRed,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tilePileOfRubble: {
		Name:      "pile of rubble",
		Change:    tileFloor,
		Lethal:    0,
		Ch:        ':',
		Color:     TGray,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileRuinedWall: {
		Name:      "ruined wall",
		Change:    tilePileOfRubble,
		Lethal:    0,
		Ch:        '#',
		Color:     TGray,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: false,
	},
	tileBloodPool: {
		Name:      "blood pool",
		Change:    tileFloor,
		Lethal:    0,
		Ch:        ':',
		Color:     TRed,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileBloodStain: {
		Name:      "blood stain",
		Change:    tileFloor,
		Lethal:    0,
		Ch:        '.',
		Color:     TRed,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileBloodyWall: {
		Name:      "bloody wall",
		Change:    tileRuinedWall,
		Lethal:    0,
		Ch:        '#',
		Color:     TLightRed,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: false,
	},
	tileCrate: {
		Name:      "crate",
		Change:    tilePileOfRubble,
		Lethal:    0,
		Ch:        '&',
		Color:     TYellow,
		Item:      true,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: true,
	},
	tileEscalatorDown: {
		Name:      "escalator down",
		Change:    tileEscalatorDown,
		Lethal:    0,
		Ch:        '>',
		Color:     TLightBlue,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: true,
	},
	tileEscalatorUp: {
		Name:      "escalator up",
		Change:    tileEscalatorUp,
		Lethal:    0,
		Ch:        '<',
		Color:     TCyan,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileClosedDoor: {
		Name:      "closed door",
		Change:    tileOpenDoor,
		Lethal:    0,
		Ch:        '/',
		Color:     TBrown,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: false,
	},
	tileOpenDoor: {
		Name:      "open door",
		Change:    tileEscalatorUp,
		Lethal:    0,
		Ch:        '\'',
		Color:     TBrown,
		Item:      false,
		Shadow:    false,
		Block:     false,
		Opaque:    false,
		Highlight: false,
	},
	tileMachinery: {
		Name:      "machinery",
		Change:    tileRuinedWall,
		Lethal:    20,
		Ch:        '$',
		Color:     TCyan,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: true,
	},
	tileBloodyMachinery: {
		Name:      "bloody machinery",
		Change:    tileRuinedWall,
		Lethal:    20,
		Ch:        '$',
		Color:     TLightRed,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: true,
	},
	tileExit: {
		Name:      "exit",
		Change:    tileExit,
		Lethal:    0,
		Ch:        'X',
		Color:     TLightGreen,
		Item:      false,
		Shadow:    false,
		Block:     true,
		Opaque:    true,
		Highlight: true,
	},
}
